﻿Imports System.Data
Imports System.Data.SqlClient

Public Class Form1
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Me.PopulateCheckBoxes()
        Me.PopulateDataGridView()
    End Sub

    Private Sub Country_Checked(ByVal sender As Object, ByVal e As EventArgs)
        Me.PopulateDataGridView()
    End Sub

    Private Sub PopulateCheckBoxes()
        Dim query As String = "SELECT DISTINCT TOP 3 Country FROM Customers"
        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                'Fill the DataTable with records from Table.
                Dim dt As DataTable = New DataTable()
                sda.Fill(dt)

                'Loop and add CheckBoxes to FloyLayoutPanel.
                For Each row As DataRow In dt.Rows
                    Dim chk As CheckBox = New CheckBox()
                    chk.Text = row("Country").ToString()
                    AddHandler chk.CheckedChanged, AddressOf Country_Checked
                    checkBoxPanel.Controls.Add(chk)
                Next
            End Using
        End Using
    End Sub

    Private Sub PopulateDataGridView()
        Dim query As String = "SELECT CustomerID, ContactName, Country FROM Customers"
        Dim condition As String = String.Empty
        For Each chk As CheckBox In checkBoxPanel.Controls.OfType(Of CheckBox)()
            condition &= If(chk.Checked, String.Format("'{0}',", chk.Text), String.Empty)
        Next

        If Not String.IsNullOrEmpty(condition) Then
            condition = String.Format(" WHERE Country IN ({0})", condition.Substring(0, condition.Length - 1))
        End If

        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query & condition, con)
                Using sda As SqlDataAdapter = New SqlDataAdapter(cmd)
                    Dim dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    dataGridView1.DataSource = dt
                End Using
            End Using
        End Using
    End Sub
End Class
